//----------------------------------------------------------------------//
// NyanFi																//
//  gqʈꗗ														//
//----------------------------------------------------------------------//
#ifndef FileExtDlgH
#define FileExtDlgH

//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <System.Actions.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.ActnList.hpp>
#include <Vcl.Menus.hpp>
#include <Vcl.Dialogs.hpp>
#include "usr_scrpanel.h"

//---------------------------------------------------------------------------
struct ext_inf_rec {
	int 	f_count;		//t@C
	__int64 f_size;			//vTCY
	__int64 oc_size;		//LTCY
	__int64 av_size;		//σTCY
	UnicodeString f_names;	//^u؂̃t@CXg(ő吔=MAX_FLIST_CNT)
};

#define MAX_FLIST_CNT	1000

//---------------------------------------------------------------------------
class TFileExtensionDlg : public TForm
{
__published:	// IDE ŊǗR|[lg
	TAction *FextClipCopyAction;
	TAction *FextCsvAction;
	TAction *FextLogOutAction;
	TAction *FextMaskFindAction;
	TAction *FextSaveAction;
	TAction *FextTsvAction;
	TAction *PropertyAction;
	TAction *ShowFileInfoAction;
	TAction *SortCntAction;
	TAction *SortDirAction;
	TAction *SortFextAction;
	TAction *SortNameAction;
	TAction *SortSizeAction;
	TActionList *ActionList1;
	TButton *HiddenCanBtn;
	THeaderControl *FextInfHeader;
	THeaderControl *FileListHeader;
	TLabel *HintLabel;
	TListBox *FileListBox;
	TListBox *InfoListBox;
	TMenuItem *FextCopyItem;
	TMenuItem *FextLogOutItem;
	TMenuItem *FextSaveItem;
	TMenuItem *FileInfoItem;
	TMenuItem *FitSizePosItem;
	TMenuItem *MaskFindItem;
	TMenuItem *RropertyItem;
	TMenuItem *SaveCsvItem;
	TMenuItem *SaveTsvItem;
	TMenuItem *Sep_1;
	TMenuItem *Sep_2;
	TMenuItem *Sep_3;
	TMenuItem *Sep_4;
	TMenuItem *SortCntItem;
	TMenuItem *SortDirItem;
	TMenuItem *SortExtItem;
	TMenuItem *SortNameItem;
	TMenuItem *SortSizeItem;
	TPanel *FilePanel;
	TPanel *HintPanel;
	TPanel *InfoPanel;
	TPanel *ListPanel;
	TPopupMenu *PopupMenu1;
	TSplitter *ListSplitter;
	TStatusBar *FextInfBar;
	TStatusBar *FileInfBar;

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall ListSplitterMoved(TObject *Sender);
	void __fastcall FextInfBarDrawPanel(TStatusBar *StatusBar, TStatusPanel *Panel, const TRect &Rect);
	void __fastcall FileInfBarDrawPanel(TStatusBar *StatusBar, TStatusPanel *Panel, const TRect &Rect);
	void __fastcall FextHeaderDrawSection(THeaderControl *HeaderControl, THeaderSection *Section,
			const TRect &Rect, bool Pressed);
	void __fastcall FextInfHeaderSectionClick(THeaderControl *HeaderControl, THeaderSection *Section);
	void __fastcall InfoListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State);
	void __fastcall InfoListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall InfoListBoxKeyPress(TObject *Sender, System::WideChar &Key);
	void __fastcall InfoListBoxClick(TObject *Sender);
	void __fastcall FileListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State);
	void __fastcall FileListBoxData(TWinControl *Control, int Index, UnicodeString &Data);
	void __fastcall FileListBoxEnter(TObject *Sender);
	void __fastcall FileListBoxExit(TObject *Sender);
	void __fastcall FileListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall FileListBoxClick(TObject *Sender);
	void __fastcall FileListHeaderSectionResize(THeaderControl *HeaderControl, THeaderSection *Section);
	void __fastcall FileListHeaderSectionClick(THeaderControl *HeaderControl, THeaderSection *Section);
	void __fastcall FextClipCopyActionExecute(TObject *Sender);
	void __fastcall FextLogOutActionExecute(TObject *Sender);
	void __fastcall FextSaveActionExecute(TObject *Sender);
	void __fastcall FextOutActionUpdate(TObject *Sender);
	void __fastcall FextCsvActionUpdate(TObject *Sender);
	void __fastcall FextMaskFindActionExecute(TObject *Sender);
	void __fastcall SortFextActionExecute(TObject *Sender);
	void __fastcall SortFextActionUpdate(TObject *Sender);
	void __fastcall SortFileActionExecute(TObject *Sender);
	void __fastcall SortFileActionUpdate(TObject *Sender);
	void __fastcall ShowFileInfoActionExecute(TObject *Sender);
	void __fastcall PropertyActionExecute(TObject *Sender);
	void __fastcall PropertyActionUpdate(TObject *Sender);

private:	// [U[錾
	TStringList *FextInfoList;
	TStringList *FileItemList;
	int TotalFileCount;
	__int64 TotalSize;
	__int64 AverageSize;
	int CurFileCount;
	int ClusterSize;

	int FExtSctWd, FCntSctWd, SizeSctWd, PercSctWd;
	int ExtSortMode, FileSortMode;
	int AccDeniedCnt;
	UnicodeString ErrMesage;

	void __fastcall WmFormShowed(TMessage &msg);

	void __fastcall WmDpiChanged(TMessage &msg)
	{
		TForm::Dispatch(&msg);
		RefreshDarkMode(this);
	}

	TWndMethod org_FextInfBarWndProc;
	void __fastcall FextInfBarWndProc(TMessage &msg)
	{
		if (msg.Msg==WM_ERASEBKGND && draw_SttBarBg(FextInfBar, msg)) return;
		org_FextInfBarWndProc(msg);
	}

	TWndMethod org_FileInfBarWndProc;
	void __fastcall FileInfBarWndProc(TMessage &msg)
	{
		if (msg.Msg==WM_ERASEBKGND && draw_SttBarBg(FileInfBar, msg)) return;
		org_FileInfBarWndProc(msg);
	}

	bool __fastcall GetInfo(UnicodeString pnam);
	void __fastcall GetResult(TStringList *lst, int mode = 0);
	void __fastcall SortListX(int mode = -1);
	void __fastcall SortListF(int mode = -1);
	void __fastcall IniSearchList(TListBox *lp, UnicodeString ptn);
	UnicodeString __fastcall GetCurFileItem(int idx = -1);

public:		// [U[錾
	UsrScrollPanel *InfoScrPanel;
	UsrScrollPanel *FileScrPanel;

	UnicodeString PathName;
	UnicodeString FileName;
	UnicodeString FextMask;

	__fastcall TFileExtensionDlg(TComponent* Owner);

	BEGIN_MESSAGE_MAP
		VCL_MESSAGE_HANDLER(WM_FORM_SHOWED,	TMessage,	WmFormShowed)
		VCL_MESSAGE_HANDLER(WM_DPICHANGED,	TMessage,	WmDpiChanged)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TFileExtensionDlg *FileExtensionDlg;
//---------------------------------------------------------------------------
#endif
